
#ifndef CRYPTMOD_H
#define CRYPTMOD_H

/*
*****************************************************************************
*
*                          Copyright (c) 2000 2005
*
*  All rights reserved.
*
*  Redistribution and use in source and binary forms, with or without 
*  modification, are permitted provided that the following conditions are met:
*
*  - Redistributions of source code must retain the above copyright notice, 
*     this list of conditions and the following disclaimer.
*  - Redistributions in binary form must reproduce the above copyright notice, 
*     this list of conditions and the following disclaimer in the documentation
*     and/or other materials provided with the distribution.
*  - The names of its contributors may not be used to endorse or promote 
*     products derived from this software without specific prior written 
*     permission.
*   
*  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
*  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
*  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
*  ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE 
*  LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
*  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
*  SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
*  INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
*  CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
*  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
*  POSSIBILITY OF SUCH DAMAGE.
*
******************************************************************************
* File          : CRYPT.h
* Author        : Zadig
* Creation date : 27/01/2005
*.............................................................................
* Modifications :
******************************************************************************
*/
#include <drivers/module.h>
#include <cryptlib.h>

/* ########################################################################## */
/* ### #define                                                                */
#define CRYPTLIB_MODULE_NAME "generic/crypt/v1"

/* ########################################################################## */
/* ### typedef                                                                */

struct cryptlib_module_info
{
   module_info module;

   int (*cryptCreateContext)( C_OUT CRYPT_CONTEXT C_PTR cryptContext,
         C_IN CRYPT_USER cryptUser, C_IN CRYPT_ALGO_TYPE cryptAlgo );
   int (*cryptDestroyContext)( C_IN CRYPT_CONTEXT cryptContext );
   int (*cryptEncrypt)( C_IN CRYPT_CONTEXT cryptContext, 
                        C_INOUT void C_PTR buffer, C_IN int length );
   int (*cryptDecrypt)( C_IN CRYPT_CONTEXT cryptContext, 
                        C_INOUT void C_PTR buffer, C_IN int length );
   int (*cryptSetAttribute)( C_IN CRYPT_HANDLE cryptHandle,
      C_IN CRYPT_ATTRIBUTE_TYPE attributeType, C_IN int value );
   int (*cryptSetAttributeString)( C_IN CRYPT_HANDLE cryptHandle,
      C_IN CRYPT_ATTRIBUTE_TYPE attributeType,
      C_IN void C_PTR value, C_IN int valueLength );
   int (*cryptGetAttribute)( C_IN CRYPT_HANDLE cryptHandle,
      C_IN CRYPT_ATTRIBUTE_TYPE attributeType,
      C_OUT int C_PTR value );
   int (*cryptGetAttributeString)( C_IN CRYPT_HANDLE cryptHandle,
      C_IN CRYPT_ATTRIBUTE_TYPE attributeType,
      C_OUT void C_PTR value,
      C_OUT int C_PTR valueLength );
   int (*cryptDeleteAttribute)( C_IN CRYPT_HANDLE cryptHandle,
      C_IN CRYPT_ATTRIBUTE_TYPE attributeType );   
};

/* ########################################################################## */
/* ### struct                                                                 */

/* ########################################################################## */
/* ### macro                                                                  */

/* ########################################################################## */
/* ### variables                                                              */

/* ########################################################################## */
/* ### functions                                                              */

#endif /* CRYPTMOD_H */
