#ifndef LOOP_MESSAGE_H
#define LOOP_MESSAGE_H

#include <Message.h>
#include <String.h>
#include <File.h>

#define LOOP_NAME_FIELD    "name"
#define LOOP_NUMBER_FIELD  "number"
#define LOOP_PATH_FIELD    "path"
#define LOOP_ALGO_FIELD    "algo"
#define LOOP_KEYTYPE_FIELD "keytype"

#define LOOP_WHAT 'Loop'

class LoopMessage : public BMessage
{
   public:
      LoopMessage();
      ~LoopMessage();

      status_t SetName(BString *psz_Name);
      status_t SetNumber(uint16 i_Number);
      status_t SetPath(BString *sz_Path);
      status_t SetAlgo(uint32 i_Algo);
      status_t SetKeyType(uint32 i_KeyType);

      status_t GetName(BString *sz_Name);
      status_t GetNumber(uint16 *pi_Number);
      status_t GetPath(BString *sz_Path);
      status_t GetAlgo(uint32 *pi_Algo);
      status_t GetKeyType(uint32 *pi_KeyType);

      status_t Enable(void);
      status_t Disable(void);
      bool IsEnabled(void);
      
      status_t Mount(void);
      status_t Unmount(void);
      bool IsMounted(void);


};

#endif
