#include <Rect.h>
#include <Box.h>
#include <Button.h>
#include <Path.h>

#include "LoopView.h"
#include "PrefMessages.h"

LoopView::LoopView(LoopPoolMessage *pc_LoopPoolMessage, BView *pc_ParentView, uint32 i_Top)
{
   float i_Width, i_Height;
   BBox *pc_LoopBox;
   BRect c_ViewRect;
   BButton *pc_AddButton, *pc_DelButton;
   
   pc_LoopPool = pc_LoopPoolMessage;
   
   c_ViewRect = pc_ParentView->Bounds();
   c_ViewRect.left += 5;
   c_ViewRect.right -= 5;
   c_ViewRect.top = i_Top + 5;
   c_ViewRect.bottom = i_Top + 160;
   
   pc_LoopBox = new BBox(c_ViewRect);
   pc_LoopBox->SetLabel("Loops");
   pc_ParentView->AddChild(pc_LoopBox);

   c_ViewRect = pc_LoopBox->Bounds();
   c_ViewRect.bottom -= 30;
   c_ViewRect.InsetBy(10,15);
   c_ViewRect.right -= B_V_SCROLL_BAR_WIDTH;
   pc_RemoteListView = new BListView(c_ViewRect, "Loops ListVew");

   pc_RemoteScrollView = new BScrollView("Loops ScrollView", pc_RemoteListView, B_FOLLOW_ALL,0,false,true);
   pc_LoopBox->AddChild(pc_RemoteScrollView);

   c_ViewRect = pc_LoopBox->Bounds();
   c_ViewRect.InsetBy(10,5);
   c_ViewRect.top = i_Top + 120;
   
   pc_AddButton = new BButton(c_ViewRect,"Add Remote", "Add",
         new BMessage(PREF_MSG_ADD_LOOP));
   pc_AddButton->GetPreferredSize(&i_Width,&i_Height);
   pc_AddButton->ResizeTo(i_Width,i_Height);
   pc_LoopBox->AddChild(pc_AddButton);

   pc_DelButton = new BButton(c_ViewRect,"Del Remote", "Del",
         new BMessage(PREF_MSG_DEL_LOOP));
   pc_DelButton->GetPreferredSize(&i_Width,&i_Height);
   pc_DelButton->ResizeTo(i_Width,i_Height);
   pc_LoopBox->AddChild(pc_DelButton);
   pc_DelButton->MoveTo(pc_AddButton->Frame().right + 20,c_ViewRect.top);

   pc_RemoteListView->SetInvocationMessage(new BMessage(LOOP_MSG_INVOKE));
   return;
}
 
LoopView::~LoopView(void)
{
   BListItem   *pc_Item;
   
   for ( int32 i = 0; pc_Item = pc_RemoteListView->ItemAt(i); i++ )
       delete pc_Item;
}

status_t LoopView::AddLoop(char *sz_Name)
{
   uint8 i;
   BStringItem *pc_Item;
   
   
   pc_Item = new BStringItem(sz_Name);
   pc_RemoteListView->AddItem(pc_Item);

   return(B_OK);
}  

status_t LoopView::DelActiveLoop(void)
{
   BStringItem   *pc_Item;
   LoopMessage    c_Loop;
   int32 i_Index;
  
   i_Index = pc_RemoteListView->CurrentSelection(0);
   if(i_Index >= 0 )
   {
      pc_Item = (BStringItem*) pc_RemoteListView->ItemAt(i_Index);
      if(pc_LoopPool->FindLoop((char*) pc_Item->Text(), &c_Loop) == B_OK)
         pc_LoopPool->DelLoop(&c_Loop);

      pc_RemoteListView->RemoveItem(pc_Item);
      return(B_OK);
   }

   return(B_ERROR);
}  

status_t LoopView::GetActiveLoopName(BString *pc_Name)
{
   BStringItem   *pc_Item;
   LoopMessage    c_Loop;
   int32 i_Index;
  
   i_Index = pc_RemoteListView->CurrentSelection(0);
   if(i_Index >= 0 )
   {
      pc_Item = (BStringItem*) pc_RemoteListView->ItemAt(i_Index);
      pc_Name->SetTo(pc_Item->Text());
      return(B_OK);
   }

   return(B_ERROR);
}  

