#ifndef PREFWINDOW_H
#define PREFWINDOW_H

/*
*****************************************************************************
*
*                          Copyright (c) 2000 2005
*
*  All rights reserved.
*
*  Redistribution and use in source and binary forms, with or without 
*  modification, are permitted provided that the following conditions are met:
*
*  - Redistributions of source code must retain the above copyright notice, 
*     this list of conditions and the following disclaimer.
*  - Redistributions in binary form must reproduce the above copyright notice, 
*     this list of conditions and the following disclaimer in the documentation
*     and/or other materials provided with the distribution.
*  - The names of its contributors may not be used to endorse or promote 
*     products derived from this software without specific prior written 
*     permission.
*   
*  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
*  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
*  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
*  ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE 
*  LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
*  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
*  SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
*  INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
*  CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
*  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
*  POSSIBILITY OF SUCH DAMAGE.
*
******************************************************************************
* File          : PrefWindow.h
* Author        : Zadig
* Creation date : 23/08/2005
*.............................................................................
* Modifications :
******************************************************************************
*/
#include <Button.h>
#include <View.h>
#include <Window.h>

#include "LoopPoolMessage.h"
#include "LoopView.h"

#define BG_COLOR ((rgb_color) {230,230,230,0})
#define LOOP_CONFIG_PATH   "/boot/home/config/settings"
#define LOOP_CONFIG_FILE   "/boot/home/config/settings/Loops"

#define W_WIDTH   200
#define W_HEIGHT  205

class PrefWindow : public BWindow
{
   public:
      PrefWindow(LoopPoolMessage *pc_LoopPool);
      ~PrefWindow(void);
      virtual void MessageReceived(BMessage *message);
      virtual bool QuitRequested();

      status_t RemoteAddRequest(BMessage *message);
   
   private:
      /* methods */

      /* variables */
      BView          *pc_MainView;
      LoopView       *pc_LoopView;
      BButton        *pc_CancelButton, *pc_ApplyButton;

      LoopPoolMessage   *pc_LoopPoolMessage;
};


#endif /* PREFWINDOW_H */
