/*
	RepView.h
*/

#ifndef HELLO_VIEW_REP_H
#define HELLO_VIEW_REP_H

#include <Bitmap.h>
#include "View.h"

#include <Messenger.h>
#include <Message.h>
#include <PopUpMenu.h>

#include "LoopPoolMessage.h"
#include "PrefWindow.h"

#define APP_SIG "application/x-vnd.zadig.CryptoloopPreference"

#define REP_MSG_ABT     'RpAb'
#define REP_MSG_QUIT    'RpQt'
#define REP_MSG_EDIT    'RpEd'
#define REP_MSG_MOUNT   'RpMt'
#define REP_MSG_UNMOUNT 'RpUM'
#define REP_MSG_ENABLE  'RpEn'
#define REP_MSG_DISABLE 'RpDs'

class _EXPORT RepView : public BView {

public:
   RepView(BRect rect); 
   RepView(BMessage *msg); 
   ~RepView();
   virtual status_t Archive(BMessage* msg, bool deep=true) const ;
   void Init();
   void AttachedToWindow() ;
   virtual void   Draw(BRect updateRect);
   static RepView* Instantiate(BMessage* msg);

   virtual void MessageReceived(BMessage *message);

   virtual void MouseDown(BPoint pos);
   BMenu *BuildActionMenu();
   BPopUpMenu *BuildMenu();

private:
   bool  b_DrawDragger;
   int   f_Manager;

   BBitmap  *pc_Bitmap;
   LoopPoolMessage   *pc_LoopPoolMessage;

   BMessenger  *pc_MyMessenger;
   BPopUpMenu  *pc_Menu;
};

#endif
