#ifndef SETTINGS_WINDOW_H
#define SETTINGS_WINDOW_H

/*
*****************************************************************************
*
*                          Copyright (c) 2000 2005
*
*  All rights reserved.
*
*  Redistribution and use in source and binary forms, with or without 
*  modification, are permitted provided that the following conditions are met:
*
*  - Redistributions of source code must retain the above copyright notice, 
*     this list of conditions and the following disclaimer.
*  - Redistributions in binary form must reproduce the above copyright notice, 
*     this list of conditions and the following disclaimer in the documentation
*     and/or other materials provided with the distribution.
*  - The names of its contributors may not be used to endorse or promote 
*     products derived from this software without specific prior written 
*     permission.
*   
*  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
*  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
*  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
*  ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE 
*  LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
*  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
*  SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
*  INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
*  CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
*  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
*  POSSIBILITY OF SUCH DAMAGE.
*
******************************************************************************
* File          : SettingsWindow.h
* Author        : Zadig
* Creation date : 28/08/2005
*.............................................................................
* Modifications :
******************************************************************************
*/
#include <Box.h>
#include <Button.h>
#include <OS.h>
#include <Screen.h>
#include <String.h>
#include <TextControl.h>
#include <View.h>
#include <Window.h>

#include "LoopPoolMessage.h"
#include "LoopMessage.h"
#include "AlgoMenu.h"

#define SETTINGS_WINDOW_BG_COLOR ((rgb_color) {230,230,230,0})

#define SETTINGS_WINDOW_WIDTH 250
#define SETTINGS_WINDOW_HEIGHT 220

#define LOOP_SET_MSG_OK     'StOk'
#define LOOP_SET_MSG_CANCEL 'StCc'
#define LOOP_SET_MSG_PATH   'StPt'

class SettingsWindow : public BWindow
{
   public:
      SettingsWindow(LoopPoolMessage *pc_LoopPoolMessage, const char *sz_Title);
      ~SettingsWindow(void);
      virtual void MessageReceived(BMessage *message);
      
      LoopMessage*   Go(void);
      virtual bool   QuitRequested();

   private:
      /* methods */

      /* variables */
      bool           b_NewLoop;
      bool           b_Cancel;
      LoopPoolMessage *pc_LoopPool;
      LoopMessage    *pc_LoopMessage;
      BView          *pc_MainView;
      BButton        *pc_OkButton, *pc_CancelButton;
      BButton        *pc_PathButton;
     
      BBox           *pc_SettingsBox, *pc_KeyBox;
      BTextControl   *pc_TargetText, *pc_LoopNumberText;
      AlgoMenu       *pc_AlgoMenu;

      sem_id         i_OkSem;

};


#endif /* SETTINGS_WINDOW_H */
