#ifndef TEXTALERT_H
#define TEXTALERT_H

/*
*****************************************************************************
*
*                          Copyright (c) 2000 2005
*
*  All rights reserved.
*
*  Redistribution and use in source and binary forms, with or without 
*  modification, are permitted provided that the following conditions are met:
*
*  - Redistributions of source code must retain the above copyright notice, 
*     this list of conditions and the following disclaimer.
*  - Redistributions in binary form must reproduce the above copyright notice, 
*     this list of conditions and the following disclaimer in the documentation
*     and/or other materials provided with the distribution.
*  - The names of its contributors may not be used to endorse or promote 
*     products derived from this software without specific prior written 
*     permission.
*   
*  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
*  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
*  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
*  ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE 
*  LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
*  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
*  SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
*  INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
*  CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
*  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
*  POSSIBILITY OF SUCH DAMAGE.
*
******************************************************************************
* File          : TextAlert.h
* Author        : Zadig
* Creation date : 27/08/2005
*.............................................................................
* Modifications :
******************************************************************************
*/
#include <Button.h>
#include <OS.h>
#include <Screen.h>
#include <String.h>
#include <TextControl.h>
#include <View.h>
#include <Window.h>

#define TEXT_ALERT_BG_COLOR ((rgb_color) {230,230,230,0})

#define TEXT_ALERT_WIDTH 250
#define TEXT_ALERT_HEIGHT 80

#define TEXT_MSG_OK  'TxOk'

class TextAlert : public BWindow
{
   public:
      TextAlert(bool b_Password, char *sz_Title);
      ~TextAlert(void);
      virtual void MessageReceived(BMessage *message);

      BString Go(void);

   private:
      /* variables */
      sem_id         i_OkSem;

      BView          *pc_MainView;
      BButton        *pc_OkButton;
      BTextControl   *pc_TextView;

      bool b_IsPassword;
};


#endif /* TEXTALERT_H */
