#ifndef _CRYPTOLOOP_H
#define _CRYPTOLOOP_H

#include <drivers/Drivers.h>
#include <cryptlib.h>

/************************
 *       Defines        *
 ************************/
#define LOOP_STRING_SIZE      128

#define LOOP_BASE_PATH        "disk/virtual/loop"

#define LOOP_IOCTL_BASE       ( (B_DEVICE_OP_CODES_END + 0x200) & 0xFFFFFF00)
#define LOOP_SET_LOOP         (LOOP_IOCTL_BASE | 0x00000000)
#define LOOP_GET_LOOP         (LOOP_IOCTL_BASE | 0x00000001)

#define LOOP_SET_ALGO         (LOOP_IOCTL_BASE | 0x00000002)
#define LOOP_GET_ALGO         (LOOP_IOCTL_BASE | 0x00000003)

#define LOOP_SET_KEY          (LOOP_IOCTL_BASE | 0x00000004)
#define LOOP_GET_KEY          (LOOP_IOCTL_BASE | 0x00000005)   /* only in dbg */

/************************
 *       Structures     *
 ************************/
typedef struct
{
   uint8 link[LOOP_STRING_SIZE];
} TS_LOOP_loop_data;

typedef struct
{
   CRYPT_ALGO_TYPE   type;
} TS_LOOP_algo_data;

typedef struct
{
   uint8 key[LOOP_STRING_SIZE];
} TS_LOOP_key_data;

typedef union
{
   TS_LOOP_loop_data loop;
   TS_LOOP_algo_data algo;
   TS_LOOP_key_data  key;
} TU_LOOP_cmd_data;

typedef struct
{
   uint8 loop[LOOP_STRING_SIZE];
   TU_LOOP_cmd_data  data;
} TS_LOOP_cmd;
/******************
 *    Functions   *
 ******************/


#endif
