

#include <Drivers.h>
#include <fcntl.h>

int main(int argc, char *argv[])
{
   int f_File;
   device_geometry   s_Geo;
   
   if(argc != 2)
      return(0);
   
   f_File = open(argv[1], O_RDONLY);
   /* f_File = open("/dev/misc/loop/loop0", O_RDONLY); */
   if(f_File >= 0)
   {
      if(ioctl(f_File, B_GET_GEOMETRY, &s_Geo) != -1)
      {
         printf("bytes_per_sector = %d\n", s_Geo.bytes_per_sector);
         printf("sectors_per_track = %d\n", s_Geo.sectors_per_track);
         printf("cylinder_count= %d\n", s_Geo.cylinder_count);
         printf("head_count= %d\n", s_Geo.head_count);
         printf("device_type= %d\n", s_Geo.device_type);
         printf("removable= %d\n", s_Geo.removable);
         printf("read_only= %d\n", s_Geo.read_only);
         printf("write_once= %d\n", s_Geo.write_once);
      }
      else
         printf("ioctl error\n");
      close(f_File);
   }
   else
      printf("open error (%d)!\n", f_File);

   return(0);
}
