
/*
*****************************************************************************
*
*                          Copyright (c) 2000 2005
*
*  All rights reserved.
*
*  Redistribution and use in source and binary forms, with or without 
*  modification, are permitted provided that the following conditions are met:
*
*  - Redistributions of source code must retain the above copyright notice, 
*     this list of conditions and the following disclaimer.
*  - Redistributions in binary form must reproduce the above copyright notice, 
*     this list of conditions and the following disclaimer in the documentation
*     and/or other materials provided with the distribution.
*  - The names of its contributors may not be used to endorse or promote 
*     products derived from this software without specific prior written 
*     permission.
*   
*  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
*  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
*  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
*  ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE 
*  LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
*  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
*  SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
*  INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
*  CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
*  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
*  POSSIBILITY OF SUCH DAMAGE.
*
******************************************************************************
* File          : secalloc.c
* Author        : Zadig
* Creation date : 25/03/2005
*.............................................................................
* Description :
******************************************************************************
*/
/* ########################################################################## */
/* ### #include                                                               */
#include <OS.h>


/* ########################################################################## */
/* ### Functions                                                              */

/* ########################################################################## */
/* ### Variables                                                              */
area_id gi_Area;

void *secalloc(uint32 i_Size)
{
   uint8 *p_Data;

   if(i_Size % B_PAGE_SIZE)
      i_Size = ((i_Size / B_PAGE_SIZE) + 1) * B_PAGE_SIZE;
   
   gi_Area = create_area( "losetup", ( void ** ) &p_Data, B_ANY_ADDRESS,
                  i_Size, B_LAZY_LOCK, B_READ_AREA | B_WRITE_AREA );

   if( (gi_Area == B_BAD_VALUE) ||
       (gi_Area == B_NO_MEMORY) ||
       (gi_Area == B_ERROR) )
   {
      return(NULL);
   }

   return(p_Data);
}

void secfree(void *ptr)
{
   delete_area(gi_Area);
}
